Avaya Client Services API Reference (OS X)

- Main Page
- Classes
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

Instance Methods | Properties | List of all members
CSCollaboration Class Reference

The CSCollaboration object provides access to collaboration related capabilities and actions. More...

`#import <CSCollaboration.h>`

Inherits NSObject.

## Instance Methods
(void) | - startWithCompletionHandler:
| Starts the collaboration session with completion handler. More...
(void) | - endWithCompletionHandler:
| Ends the collaboration session with completion handler. More...
(void) | - getParticipantListWithCompletionHandler:
| Return the participant list associated with the collaboration session. More...
(void) | - readCollaborationDetailsWithCompletionHandler:
| Deprecated please use acquireCollaborationDetailsWithCompletionHandler: . More...
(void) | - acquireCollaborationDetailsWithCompletionHandler:
| Returns the details associated with the collaboration. More...
(void) | - pauseReceivingSharingWithCompletionHandler:
| Pauses receiving certain collaboration sharing updates. More...
(void) | - resumeReceivingSharingWithCompletionHandler:
| Resumes receiving certain collaboration sharing updates. More...

## Properties
id< CSCollaborationDelegate > | delegate
| The delegate used to handle collaboration-related events. More...
NSUInteger | collaborationId
| The collaboration ID associated with the particular collaboration object. More...
NSInteger | callId
| The call ID associated with the particular collaboration object. More...
CSCapability * | contentSharingCapability
| CSCapability object indicating whether collaboration supports content sharing. More...
CSContentSharing * | contentSharing
| CSContentSharing object associated with the collaboration. More...
CSCapability * | chatCapability
| CSCapability object indicating whether in-conference chat is supported. More...
CSChat * | chat
| CSChat object associated with the collaboration. More...
CSCapability * | meetingMinutesCapability
| CSCapability object indicating whether collaboration call supports meeting minutes. More...
CSMeetingMinutes * | meetingMinutes
| CSMeetingMinutes object associated with the conference call. More...
CSCapability * | networkLibraryCapability
| CSCapability object indicating whether collaboration call supports network library. More...
CSLibraryManager * | libraryManager
| CSLibraryManager object associated with the collaboration. More...
CSCapability * | librarySharingCapability
| CSCapability object indicating whether collaboration call supports library sharing. More...
CSLibrarySharing * | librarySharing
| CSLibraryManager object provides set of APIs which allow to access different features concerning library sharing. More...
CSCapability * | whiteboardCapability
| CSCapability object indicating whether whiteboard sharing can be started by local participant. More...
CSWhiteboard * | whiteboard
| CSWhiteboard object associated with the collaboration. More...
CSCapability * | sliderCapability
| Returns CSCapability object indicating whether the slider feature is available. More...
CSSlider * | slider
| Returns CSSlider object associated with the collaboration. More...
CSCapability * | retrieveParticipantListCapability
| CSCapability object indicating whether the conference call can be queried to get the list of conference participants. More...
BOOL | initialized
| A Boolean value indicating whether all starting events coming from server have been processed or, another words, when local collaboration state is synchronized with server. More...
BOOL | hasPresenterPrivilege
| Indicates whether the current collaboration user has presenter privileges. More...
BOOL | hasModeratorPrivilege
| Indicates whether the current collaboration user has moderator privileges. More...
BOOL | ejected
| Indicates that the current user was ejected from the collaboration by the moderator. More...
CSCollaborationCapabilities * | capabilities
| CSCollaborationCapabilities object containing set of collaboration capabilities. More...
CSCollaborationRenderType | collaborationRenderType
| Returns the type of renderer. More...
BOOL | receivingSharingPaused
| Returns true if receiving sharing is paused. More...
CSCapability * | receivingSharingControlCapability
| Returns CSCapability object indicating whether it is possible to control receiving sharing. More...

## Detailed Description

The CSCollaboration object provides access to collaboration related capabilities and actions.

The CSCollaboration object is accessible via CSCollaborationService and provides a set of APIs that allow application developers to access different features and services provided by Avaya's various collaboration solutions.

In general, the capabilities and the set of allowed operations are not only dependent on the capabilities of the conferencing server, but also on the specific privileges assigned to the local user on the collaboration call. The local user may have moderator and/or presenter capabilities. Status updates concerning collaboration are reported through the CSCollaborationDelegate object.

See also
  CSCollaborationDelegate

## Method Documentation

- (void) acquireCollaborationDetailsWithCompletionHandler: |  | (void(^)(CSCollaborationDetails *, NSError *)) | handler |

Returns the details associated with the collaboration.

- (void) endWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Ends the collaboration session with completion handler.

Collaboration can not be ended twice or during collaboration starting or ending process.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) getParticipantListWithCompletionHandler: |  | (void(^)(NSDictionary *participantList)) | handler |

Return the participant list associated with the collaboration session.

Depending on the capabilities of the collaboration session, the list of participants may not be provided (e.g., when presentation is supported through RTP video stream and not through the web collaboration interface). This method is added to support collaboration only sessions where there is no corresponding audio/video conference call. This method may be called when the collaboration session is associated with a conference call. The call/conference object may be queried to retrieve the full list of participants whereas this method may be used to retrieve the collaboration-only participants. Updates to the participant list (add, remove or update) are reported through the DataSetChangeListener instance registered with the DataSet object.

Parameters

  handler | A block to be called when the operation is completed. `participantList` If the operation was successful this parameter contains list of collaboration participants.

- (void) pauseReceivingSharingWithCompletionHandler: |  | (CSReceivingSharingControlCompletionHandler) | completionHandler |

Pauses receiving certain collaboration sharing updates.

Currently stops content sharing image updates and whiteboard drawing updates.

Can be used to reduce application event-handling workload in situations when sharing does not need to be processed (e.g. sharing-related UI components are hidden).

Receiving sharing can be started again with resumeReceivingSharingWithCompletionHandler: without losing any intermediate data (i.e. the up-to-date content sharing key frame and all whiteboard drawing events will be eventually received).

Succeeds if receiving sharing is already paused.

See also
  - resumeReceivingSharingWithCompletionHandler:

Parameters

  completionHandler | Completion handler instance used to report that the operation finished.

- (void) readCollaborationDetailsWithCompletionHandler: |  | (void(^)(CSCollaborationDetails *)) | handler |

Deprecated please use acquireCollaborationDetailsWithCompletionHandler: .

- (void) resumeReceivingSharingWithCompletionHandler: |  | (CSReceivingSharingControlCompletionHandler) | completionHandler |

Resumes receiving certain collaboration sharing updates.

Starts receiving sharing updates previously paused by pauseReceivingSharingWithCompletionHandler:.

Succeeds if receiving sharing is already resumed.

See also
  - pauseReceivingSharingWithCompletionHandler:

Parameters

  completionHandler | Completion handler instance used to report that the operation finished.

- (void) startWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Starts the collaboration session with completion handler.

Collaboration can not be started twice or during collaboration starting or ending process.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

## Property Documentation

- (NSInteger) callId
| read nonatomic assign

The call ID associated with the particular collaboration object.

See also
  CSCall

- (CSCollaborationCapabilities*) capabilities
| read nonatomic assign

CSCollaborationCapabilities object containing set of collaboration capabilities.

- (CSChat*) chat
| read nonatomic assign

CSChat object associated with the collaboration.

CSChat object can be used to query for list of messages or send a new message. Object accessible also via CSConference

See also
  CSConference::inConferenceChat

- (CSCapability*) chatCapability
| read nonatomic assign

CSCapability object indicating whether in-conference chat is supported.

Object accessible also via CSConference. For more information see CSConference::inConferenceChat

See also
  CSConference::inConferenceChat

- (NSUInteger) collaborationId
| read nonatomic assign

The collaboration ID associated with the particular collaboration object.

- (CSCollaborationRenderType) collaborationRenderType
| read nonatomic assign

Returns the type of renderer.

Client may use this information to create proper renderer to display collaboration content.

- (CSContentSharing*) contentSharing
| read nonatomic assign

CSContentSharing object associated with the collaboration.

CSContentSharing object provides set of APIs which allow to access different features concerning receiving and sharing content.

- (CSCapability*) contentSharingCapability
| read nonatomic assign

CSCapability object indicating whether collaboration supports content sharing.

See also
  CSContentSharing

- (id<CSCollaborationDelegate>) delegate
| read write nonatomic weak

The delegate used to handle collaboration-related events.

- (BOOL) ejected
| read nonatomic assign

Indicates that the current user was ejected from the collaboration by the moderator.

- (BOOL) hasModeratorPrivilege
| read nonatomic assign

Indicates whether the current collaboration user has moderator privileges.

Collaboration participant can be promoted to moderator but the original moderator loses moderator control.

- (BOOL) hasPresenterPrivilege
| read nonatomic assign

Indicates whether the current collaboration user has presenter privileges.

Collaboration participant can be promoted to presenter. In panel mode conference all users are presenters.

- (BOOL) initialized
| read nonatomic assign

A Boolean value indicating whether all starting events coming from server have been processed or, another words, when local collaboration state is synchronized with server.

- (CSLibraryManager*) libraryManager
| read nonatomic assign

CSLibraryManager object associated with the collaboration.

CSLibraryManager object provides set of APIs which allow to access different features concerning network library management.

See also
  networkLibraryCapability.

- (CSLibrarySharing*) librarySharing
| read nonatomic assign

CSLibraryManager object provides set of APIs which allow to access different features concerning library sharing.

- (CSCapability*) librarySharingCapability
| read nonatomic assign

CSCapability object indicating whether collaboration call supports library sharing.

See also
  CSLibraryManager

- (CSMeetingMinutes*) meetingMinutes
| read nonatomic assign

CSMeetingMinutes object associated with the conference call.

CSMeetingMinutes object can be used to query for list of minutes or to add a new minute, or edit or remove an existing minute. Object accessible also via CSConference.

See also
  CSConference::meetingMinutes

- (CSCapability*) meetingMinutesCapability
| read nonatomic assign

CSCapability object indicating whether collaboration call supports meeting minutes.

Object accessible also via CSConference. For more information see CSConference::inConferenceChat

See also
  CSConference::meetingMinutesCapability
  CSMeetingMinutes

- (CSCapability*) networkLibraryCapability
| read nonatomic assign

CSCapability object indicating whether collaboration call supports network library.

See also
  CSLibraryManager

- (CSCapability*) receivingSharingControlCapability
| read nonatomic assign

Returns CSCapability object indicating whether it is possible to control receiving sharing.

The capability is:

- CSCapabilityNotSupported if control is not supported.
- CSCapabilityNetworkUnavailable if control is temporarily unavailable due to connection loss.
- CSCapabilityNotDenied otherwise.

See also
  - pauseReceivingSharingWithCompletionHandler:
  - resumeReceivingSharingWithCompletionHandler:
  CSCollaboration::receivingSharingPaused

- (BOOL) receivingSharingPaused
| read nonatomic assign

Returns true if receiving sharing is paused.

Initially set to false.

Changes to true after a call to the pauseReceivingSharingWithCompletionHandler: method succeeds. Changes to false again after a subsequent call to the resumeReceivingSharingWithCompletionHandler: method succeeds.

See also
  receivingSharingControlCapability
  - pauseReceivingSharingWithCompletionHandler:
  - resumeReceivingSharingWithCompletionHandler:

- (CSCapability*) retrieveParticipantListCapability
| read nonatomic assign

CSCapability object indicating whether the conference call can be queried to get the list of conference participants.

Object accessible also via CSConference. For more information see CSConference::retrieveParticipantListCapability.

See also
  CSConference::retrieveParticipantListCapability

- (CSSlider*) slider
| read nonatomic assign

Returns CSSlider object associated with the collaboration.

Shall not be nil.

- (CSCapability*) sliderCapability
| read nonatomic assign

Returns CSCapability object indicating whether the slider feature is available.

The capability is:

- CSCapabilityNotSupported if slider is not supported by this collaboration instance.
- CSCapabilityInvalidState before the collaboration is started or after it has ended.
- CSCapabilityNetworkUnavailable if slider is temporarily unavailable due to connection loss.
- CSCapabilityNotDenied otherwise.

See also
  CSSlider

- (CSWhiteboard*) whiteboard
| read nonatomic assign

CSWhiteboard object associated with the collaboration.

CSWhiteboard object provides set of APIs which allow to access different features concerning receiving and sharing whiteboard.

- (CSCapability*) whiteboardCapability
| read nonatomic assign

CSCapability object indicating whether whiteboard sharing can be started by local participant.

Note that CSWhiteboardDelegate delegate added to CSWhiteboard object may still receive messages even if this capability is not allowed. E.g. if local user does not have the required permissions to start whiteboard sharing, but it was started by another collaboration participant.

See also
  CSWhiteboard

The documentation for this class was generated from the following file:

- CSCollaboration.h